unit fixunit;
{$N+,E-,G+,S-,E-,Q-,A+}
{$define withcounterdisplay}

interface
Type kenntyp=array[1..8] of char;

Type  pararec= record
      kennx:kenntyp;
      minerr:double;
      abbruch:word ;
      Noprobe:word ;
      Display:word ;
      end;

const para:pararec=
      (kennx:'ctPTB1.0';
       minerr:1e-15;  {maximaler zulssiger Fehler}
       abbruch:0;
       Noprobe:0;
       Display:1      { nur fr Diagnose }

       );

const bugfixok:boolean=false;
const quietmode:boolean=false;
const installx:boolean=false;
const loesch:boolean=false;
const optionstr: string='';

Procedure setkonfig; { Optionstr auswerten }
Procedure Getkonfig;


implementation
uses dos;

{$ifdef withcounterdisplay}
 {$L Fdivfixd.obj}
{$else}
 {$L Fdivfix.obj}
{$endif}

Procedure emu_int; far; external;
Procedure fdivfixinstall; far; external;
Procedure fdivparas; far;external;
Procedure fdivsetparas; far;external;

var z:double;

{$ifdef withcounterdisplay}

procedure dprint(s:char;x:byte;a:word);   {x in hex bzw. BCD}
var u:byte;
begin
{ Direktes Scheiben in den Video-Speicher,
  nicht zu empfehlen bei alten CGAs }
if s <> #0 then
  begin
  memw[$B800:a]:=$4000+byte(s);
  inc (a,2);
  end;
u:=x shr 4;
if u > 9 then inc (u,7);
memw[$B800:a]:= u+ $4030;
u:=x mod 16;
if u > 9 then inc (u,7);
memw[$B800:a+2]:= u +$4030;
end;


procedure intcount(Flags, CS, IP, AX, BX,
  CX, DX, SI, DI, DS, ES, BP: Word);
interrupt;
Type Longintptr=^Longint;
var x:longint;
    a:array[0..1] of word absolute x;
    i:integer;
    wert:^byte;
    start:word;

procedure countertab;
assembler;  { im code segment }
asm
@cnt1:dd 0
@cnt2:dd 0
@cnt3:dd 0
@cnt4:dd 0
end;

function cntptr (nr:integer):longintptr;
begin
cntptr:=ptr(seg(countertab),ofs(countertab)+4*nr-1);
end;

begin
 x:=0;
 if ax=0 then for i:=1 to 4 do cntptr(i)^:=0
 else
 if ax <= 4 then
  begin
  inc (cntptr(ax)^);
  start:=2*(18*80 + 42);
  for i:=1 to 4 do
   begin
   x:=cntptr(i)^;
   dprint  (' ',hi(a[1]),start);
   dprint  (#0,lo(a[1]),start+6);
   dprint  (#0,hi(a[0]),start+10);
   dprint  (#0,lo(a[0]),start+14);
   inc (start,18);
   end;
  end;
end;

{$endif}

Function pentiumbug: boolean;
var x,y: double;
{ Achtung Pentium-Bug wird vor  der Korrektur
  konvertiert, Bugfix wirkt daher nicht !!}

begin
 x:=8391667;
 y:=1572863;
 z:=x/y;
 if (x-(x/y)*y) > 1 then pentiumbug:=true
                    else pentiumbug:=false;
end;


Function pentiumbug2: boolean;
{ Nach der Korrektur, Bugfix aktiv !!}
var x,y:double;
begin
 x:=8391667;
 y:=1572863;
 z:=x/y;
 if (x-(x/y)*y) > 1 then pentiumbug2:=true
                    else pentiumbug2:=false;
end;

Procedure InstallFDIVEmulator;
var altint:pointer;
begin
 Fdivfixinstall;
 saveint34:=@emu_int;
 saveint35:=@emu_int;
 saveint36:=@emu_int;
 saveint38:=@emu_int;
 saveint3A:=@emu_int;
 saveint3C:=@emu_int;
 {$ifdef withcounterdisplay}
  setintvec($8F,@intcount);
 {$endif}
 bugfixok:=true;
end;

Procedure setkonfig;
var int34:pointer;
    dest:pointer;
    i:word;
begin
 getintvec ($34,int34);
 dest:=ptr(seg(int34^),ofs(fdivparas));
 if kenntyp(dest^) <> para.kennx then
   begin
   Write ('residenten Bugfix nicht gefunden');
   exit;   { huch, wat dat ? }
   end;
  move (para,dest^,sizeof(para));                 { Konfiguration eintragen }
 {$ifdef withcounterdisplay}
  if loesch  or bugfixok then
  asm
  mov ax,0
  Int $8F
  end;
 {$endif}
end;

Procedure Getkonfig; { Environmentvariable FDIVFIX auswerten }
var i:longint;
    result:integer;
begin
for i:=1 to length (optionstr) do with para do
 case upcase(optionstr[i]) of
 'Q': quietmode:=true;  { Keine Installer-Meldung }
 'I': installx:=true;    { auch bei fehlerfreiem System installieren }
 'A': abbruch:=word(true);    { Programmabbruch bei Pentium-Fehler }
 'N': Noprobe:=word(true);    { Keine Probe auf Fehler > Minerr, aber Korrektur}
 'M': val(copy(optionstr,i+1,255),minerr,result);
 {$ifdef withcounterdisplay}
 'D': display:=word(true);    { Anzeige der FPU-Befehlszhler }
 'X' :display:=word(false);   { Abschalten der Anzeige }
 'L' :Loesch:=true;           { Lschen der Zhler }
 {$endif}
end;
end;


var i:integer;
begin
optionstr:= getenv ('FDIVFIX');
Getkonfig;
if not quietmode then
 begin
 Writeln ('Pentium-Bugfix fr FDIV und FPREM unter DOS, c''t 2/95 Andreas Stiller');
 If pentiumbug then Writeln ('Fehlerhaften Pentium erkannt')
               else Writeln ('Keinen fehlerhaften Pentium entdeckt');
 end;
If pentiumbug or installx then InstallFDIVEmulator;
if bugfixok and not quietmode then for i:=1 to  10000 do  pentiumbug;
setkonfig;

end.


